
#ifdef GL_ES
precision mediump float;

varying mediump	vec2	v_texCoord;
#else
varying			vec2	v_texCoord;
#endif

uniform float	u_blurRadius;

//the amount to blur, i.e. how far off center to sample from 
//1.0 -> blur by one pixel
//2.0 -> blur by two pixels, etc.
//const float blur	= 0.0029296875;//1.5/512
//const float blur	= 0.001953125;//1.0/512
const float blur	= 0.00390625;//1.0/256


void main()			
{
    vec2 tc = v_texCoord;

    //float blur = radius/resolution; 

    //apply blurring, using a 9-tap filter with predefined gaussian weights

	vec3 color	= vec3(0.0);
	
	// Horizontal /////////////////////////////////
	/*
    color	+= texture2D(CC_Texture0, vec2(tc.x - 4.0*u_blurRadius, tc.y)).rgb * 0.0162162162;
    color	+= texture2D(CC_Texture0, vec2(tc.x - 3.0*u_blurRadius, tc.y)).rgb * 0.0540540541;
    color	+= texture2D(CC_Texture0, vec2(tc.x - 2.0*u_blurRadius, tc.y)).rgb * 0.1216216216;
    color	+= texture2D(CC_Texture0, vec2(tc.x - 1.0*u_blurRadius, tc.y)).rgb * 0.1945945946;

    color	+= texture2D(CC_Texture0, vec2(tc.x, tc.y)).rgb * 0.2270270270;

    color	+= texture2D(CC_Texture0, vec2(tc.x + 1.0*u_blurRadius, tc.y)).rgb * 0.1945945946;
    color	+= texture2D(CC_Texture0, vec2(tc.x + 2.0*u_blurRadius, tc.y)).rgb * 0.1216216216;
    color	+= texture2D(CC_Texture0, vec2(tc.x + 3.0*u_blurRadius, tc.y)).rgb * 0.0540540541;
    color	+= texture2D(CC_Texture0, vec2(tc.x + 4.0*u_blurRadius, tc.y)).rgb * 0.0162162162;
	*/
	
	color += texture2D(CC_Texture0, vec2(tc.x - 7.0*u_blurRadius, tc.y)).rgb * 0.0044299121055113265;
	color += texture2D(CC_Texture0, vec2(tc.x - 6.0*u_blurRadius, tc.y)).rgb * 0.00895781211794;
	color += texture2D(CC_Texture0, vec2(tc.x - 5.0*u_blurRadius, tc.y)).rgb * 0.0215963866053;
	color += texture2D(CC_Texture0, vec2(tc.x - 4.0*u_blurRadius, tc.y)).rgb * 0.0443683338718;
	color += texture2D(CC_Texture0, vec2(tc.x - 3.0*u_blurRadius, tc.y)).rgb * 0.0776744219933;
	color += texture2D(CC_Texture0, vec2(tc.x - 2.0*u_blurRadius, tc.y)).rgb * 0.115876621105;
	color += texture2D(CC_Texture0, vec2(tc.x - 1.0*u_blurRadius, tc.y)).rgb * 0.147308056121;
	color += texture2D(CC_Texture0, tc).rgb * 0.159576912161;
	color += texture2D(CC_Texture0, vec2(tc.x + 1.0*u_blurRadius, tc.y)).rgb * 0.147308056121;
	color += texture2D(CC_Texture0, vec2(tc.x + 2.0*u_blurRadius, tc.y)).rgb * 0.115876621105;
	color += texture2D(CC_Texture0, vec2(tc.x + 3.0*u_blurRadius, tc.y)).rgb * 0.0776744219933;
	color += texture2D(CC_Texture0, vec2(tc.x + 4.0*u_blurRadius, tc.y)).rgb * 0.0443683338718;
	color += texture2D(CC_Texture0, vec2(tc.x + 5.0*u_blurRadius, tc.y)).rgb * 0.0215963866053;
	color += texture2D(CC_Texture0, vec2(tc.x + 6.0*u_blurRadius, tc.y)).rgb * 0.00895781211794;
	color += texture2D(CC_Texture0, vec2(tc.x + 7.0*u_blurRadius, tc.y)).rgb * 0.0044299121055113265;
	

	gl_FragColor	= vec4(color,1.0);
}				
