
attribute vec4 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;

#ifdef GL_ES
varying lowp	vec4 v_color;
varying mediump	vec2 v_texCoord;
#else
varying vec4	v_color;
varying vec2	v_texCoord;
#endif

uniform vec3	u_curveOrigin;
uniform vec3	u_offsetOrigin;
uniform float	u_curveRadius;
uniform float	u_offsetHeight;
uniform float	u_offsetFreq;

void main()
{
	vec3  Rc		= a_position.xyz - u_curveOrigin;
	float radius	= length(Rc);
	float curveX	= Rc.x/u_curveRadius;
	float curveY	= -Rc.y/u_curveRadius;
	float offsetX	= u_offsetFreq*(sin((a_position.x - u_offsetOrigin.x)/2.0));
	float offsetY	= u_offsetFreq*(sin((a_position.y - u_offsetOrigin.y)/3.0));

	vec2 vs			= vec2(sin(curveX),sin(curveY));
	vec2 vc			= vec2(cos(curveX),cos(curveY));
	mat3 Mx			= mat3(	vc.x,	0.0,	vs.x,
							0.0,	1.0,	0.0,
							-vs.x,	0.0,	vc.x );
	
	mat3 My			= mat3(	1.0,	0.0,	0.0,
							0.0,	vc.y,	-vs.y,
							0.0,	vs.y,	vc.y );

	mat3 Mcurve		= Mx * My;
	vec4 wp			= vec4(u_curveOrigin + Mcurve * (vec3(0.0,0.0,Rc.z)),a_position.w) + vec4(0,0,u_offsetHeight*(sin(offsetX) + sin(offsetY)),0);
	gl_Position		= CC_MVPMatrix * wp;
	
	v_color		= a_color;
	v_texCoord	= a_texCoord;
}