
#ifdef GL_ES
precision mediump float;

varying highp	vec4	v_mpos;
varying highp	vec4	v_spos;
varying lowp	vec4	v_color;
varying lowp	vec3	v_fogColor;
varying mediump float	v_fogParam;
#else
varying			vec4	v_mpos;
varying			vec4	v_spos;
varying			vec4	v_color;
varying			vec3	v_fogColor;
varying			float	v_fogParam;
#endif

uniform vec3	u_fogA;
uniform vec3	u_fogB;
uniform vec3	u_fogC;
uniform float	u_fogMin;
uniform float	u_fogMax;
uniform float	u_fogHeight;

void main()			
{
	/*
	float tFog		= clamp(v_mpos.y/u_fogHeight + 0.5,0.0,1.0);
	float tFogA		= smoothstep(0.0,1.0,min(tFog/0.5,1.0));
	float tFogB		= smoothstep(0.0,1.0,max((tFog-0.5)/0.5,0.0));
	vec3 fogColor	= mix(mix(u_fogA,u_fogB,tFogA),u_fogC,tFogB);
	float fogParam	= max((length(v_mpos.xyz)-u_fogMin)/(u_fogMax-u_fogMin),0.0);
	*/
	
	//float tFog		= clamp(1.0-(gl_FragCoord.y/u_fogHeight),0.0,1.0);
	float tFog		= clamp((-v_spos.y/v_spos.w)*0.5 + 0.5,0.0,1.0);
	float tFogA		= smoothstep(0.0,1.0,min(tFog/0.5,1.0));
	float tFogB		= smoothstep(0.0,1.0,max((tFog-0.5)/0.5,0.0));

	float fogOffset	= 1.0 - 0.3*pow(tFog,2.0);
	float fogDist	= (u_fogMax-u_fogMin)*fogOffset;
	float fogParam	= clamp((length(v_mpos.xyz)-u_fogMin*fogOffset)/fogDist,0.0,1.0);
	
	//vec3 fogB2		= mix(u_fogB,u_fogC,pow(fogParam,6.0));
	//vec3 fogColor	= mix(mix(u_fogA,fogB2,tFogA),u_fogB,tFogB);
	vec3 fogColor	= mix(mix(u_fogA,u_fogC,tFogA),u_fogB,tFogB);
	gl_FragColor	= vec4(mix(v_color.rgb,fogColor,smoothstep(0.0,1.0,fogParam)),v_color.a);
}				
