
#ifdef GL_ES

precision mediump float;

varying highp	vec4 v_mpos;
varying mediump	vec3 v_normal;
varying lowp	vec4 v_color;
#else
varying vec4	v_mpos;
varying vec3	v_normal;
varying vec4	v_color;
#endif

uniform vec3	u_lightDir;
uniform vec3	u_lightAmbient;
uniform vec3	u_lightDiffuse;
uniform vec3	u_lightSpecular;
uniform float	u_specOpacity;
uniform float	u_specPower;

void main()			
{
	vec3 eye		= normalize(v_mpos.xyz)*-1.0;
	vec3 N			= normalize(v_normal);
	
	float refDot	= max(dot(reflect(u_lightDir,N),eye),0.0);
	vec3 cSpec		= u_lightSpecular.rgb*( pow( refDot, u_specPower ) );

	float lightDot	= clamp( dot( N,u_lightDir )*-1.0, 0.0, 1.0 );
	
	vec3 c2			= min( v_color.rgb*(u_lightAmbient + u_lightDiffuse*(lightDot)) + (cSpec)*(u_specOpacity), vec3(1.0) );
	gl_FragColor	= vec4(c2,v_color.a);
}				
