
attribute vec4 a_position;
attribute vec3 a_normal;
attribute vec2 a_texCoord;
attribute vec4 a_color;

#ifdef GL_ES
varying highp	vec4	v_mpos;
varying mediump	vec3	v_normal;
varying lowp	vec4	v_color;
varying mediump	vec2	v_texCoord;
varying mediump	vec4	v_shadowCoord;
varying lowp	vec3	v_fogColor;
varying mediump float	v_fogParam;
#else
varying			vec4	v_mpos;
varying			vec3	v_normal;
varying			vec4	v_color;
varying			vec2	v_texCoord;
varying			vec4	v_shadowCoord;
varying			vec3	v_fogColor;
varying			float	v_fogParam;
#endif

uniform mat4	u_shadowMatrix;

void main()
{
	gl_Position		= CC_MVPMatrix * a_position;
	v_normal		= CC_NormalMatrix * a_normal;
	v_mpos			= CC_MVMatrix * a_position;
	v_color			= a_color;
	v_texCoord		= a_texCoord;
	v_shadowCoord	= u_shadowMatrix * a_position;
}