
#ifdef GL_ES
precision mediump float;

varying highp	vec4	v_mpos;
varying lowp	vec4	v_color;
varying mediump	vec2	v_texCoord;
#else
varying			vec4	v_mpos;
varying			vec4	v_color;
varying			vec2	v_texCoord;
#endif

uniform vec3	u_wallOrigin;
uniform float	u_wallRange;
uniform float	u_wallParamA;
uniform float	u_wallParamB;

void main()			
{
	float dist		= length(v_mpos.xyz - u_wallOrigin);
	float fadeA		= 1.0 - pow(clamp(dist/(u_wallParamA*u_wallRange),0.0,1.0),4.0);
	float fadeB		= pow(clamp(dist/(u_wallParamB*2.0*u_wallRange),0.0,1.0),4.0);
	gl_FragColor	= vec4(v_color.rgb,fadeA*fadeB*v_color.a*texture2D(CC_Texture0,v_texCoord).a);
}				
